# ALTerator::Backend3 module

module ALTerator

  class Backend3

    attr_accessor :source

    def initialize (source = $stdin)
      @source = source
      @message_block = nil
    end

    def on_message (&block)
      @message_block = block
    end

    def message_loop ()
      message = Hash.new
      reading = false
      @source.each_line do |line|
        line.chomp!
        if line == "_message:begin"
          message = Hash.new
          reading = true
        elsif reading and line == "_message:end"
          reading = false
          if block_given?
            yield message
          else
            @message_block.call(message)
          end
        else
          name, value = line.split(/:/, 2)

          value.gsub!(/([^\\])\\n/, "\\1\n")
          value.gsub!(/\\\\/, "\\")

          message[name.to_sym] = value
        end
      end
    end

  end

end

# vim: set ts=4 sw=2 et:
